SystemOrganization addCategory: #'BlobFollower-Core'!

!WebCamMorph methodsFor: '*BlobFollower-Core' stamp: 'Richo 2/27/2014 09:49'!
form
	^ displayForm deepCopy! !

Object subclass: #ImageAnalyzer
	instanceVariableNames: 'source trackedColor hueMargin saturationMargin brightnessMargin last fails fps times frames lastTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlobFollower-Core'!

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Tera 9/17/2012 14:02'!
apiGetColumnSkip
	<cdecl: long 'getColumnSkip' ( void) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Tera 9/17/2012 14:02'!
apiGetRectangleOverlapping
	<cdecl: long 'getRectangleOverlapping' ( void) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Tera 9/17/2012 14:02'!
apiGetRowSkip
	<cdecl: long 'getRowSkip' ( void) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetColumnSkip: value
	<cdecl: void 'setColumnSkip' ( long) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:09'!
apiSetHue: min max: max
	<cdecl: void 'setHue' (double double) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetRectangleOverlapping: value
	<cdecl: void 'setRectangleOverlapping' ( long) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetRowSkip: value
	<cdecl: void 'setRowSkip' ( long) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetSat: min max: max
	<cdecl: void 'setSaturation' (double double) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiSetV: min max: max
	<cdecl: void 'setBrightness' (double double) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'primitives' stamp: 'Richo 9/18/2012 15:10'!
apiTrackMainRectangle: aBitmap width: w height: h
	<cdecl: ImageRectangle 'trackMainRectangle' (ushort* long long) module: 'ImageAnalyzer.dll'>
	^ self externalCallFailed! !

!ImageAnalyzer class methodsFor: 'instance creation' stamp: 'Richo 9/18/2012 15:06'!
on: aMorph track: trackedColor h: hueMargin s: saturationMargin v: brightnessMargin
	^ self basicNew
		initializeWith: aMorph
		trackedColor: trackedColor
		hueMargin: hueMargin
		saturationMargin: saturationMargin
		brightnessMargin: brightnessMargin! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:24'!
blobFound
	^ fails <= 10! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
brightnessMargin
	"Answer the value of brightnessMargin"

	^ brightnessMargin! !

!ImageAnalyzer methodsFor: 'initialize-release' stamp: 'Richo 9/18/2012 16:25'!
configure
	self class
		apiSetHue: trackedColor hue - hueMargin
		max: trackedColor hue + hueMargin;
		apiSetSat: trackedColor saturation - saturationMargin
		max: trackedColor saturation + saturationMargin;
		apiSetV: trackedColor brightness - brightnessMargin 
		max: trackedColor brightness + brightnessMargin ! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:32'!
form
	| form |
	form := true caseOf: {
		[source isKindOf: WebCamMorph]
			-> [source form].
		[source isKindOf: SketchMorph]
			-> [source rotatedForm].
		[source isKindOf: Morph]
			-> [source imageForm]
	}.
	form depth ~= 16
		ifTrue: [form := form asFormOfDepth: 16].
	^ form! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 17:34'!
fps
	^ fps! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
hueMargin
	"Answer the value of hueMargin"

	^ hueMargin! !

!ImageAnalyzer methodsFor: 'initialize-release' stamp: 'Richo 9/18/2012 17:37'!
initializeWith: aMorph 
trackedColor: aColor
hueMargin: hue
saturationMargin: saturation
brightnessMargin: brightness

	fails := fps := 0.
	frames := 0.
	source := aMorph.
	trackedColor := aColor.
	hueMargin := hue.
	saturationMargin := saturation.
	brightnessMargin := brightness.
	self configure;
		initialize! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
saturationMargin
	"Answer the value of saturationMargin"

	^ saturationMargin! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
source
	"Answer the value of source"

	^ source! !

!ImageAnalyzer methodsFor: 'tracking' stamp: 'Richo 9/18/2012 17:41'!
track
	| form rect |
	form := self form.
	frames >= 10
		ifTrue: [lastTime
			ifNil: [lastTime := Time millisecondClockValue]
			ifNotNil: [fps := 1000 / (Time millisecondClockValue - lastTime / 10)].
				frames := 0.
				lastTime := Time millisecondClockValue]
		ifFalse: [frames := frames + 1].
	rect := self class 
		apiTrackMainRectangle: form bits
		width: form width
		height: form height.
	(form boundingBox containsPoint: rect centerX @ rect centerY)
		ifTrue: [fails := 0.
			^ last := Rectangle
				origin: rect left @ rect top
				corner: rect right @ rect bottom]
		ifFalse: [(last isNil or: [fails > 10])
			ifTrue: [^ form boundingBox]
			ifFalse: [fails := fails + 1.
				^ last]]! !

!ImageAnalyzer methodsFor: 'accessing' stamp: 'Richo 9/18/2012 15:37'!
trackedColor
	"Answer the value of trackedColor"

	^ trackedColor! !

ExternalStructure subclass: #ImageRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BlobFollower-Core'!

!ImageRectangle class methodsFor: 'as yet unclassified' stamp: 'Richo 9/12/2012 16:16'!
fields
	"
	self defineFields.
	"
	^ #(
	(left 'long') 
	(top 'long') 
	(right 'long') 
	(bottom 'long') 
	(centerX 'long')
	(centerY 'long') )! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
bottom
	"This method was automatically generated"
	^handle signedLongAt: 13! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
bottom: anObject
	"This method was automatically generated"
	handle signedLongAt: 13 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
centerX
	"This method was automatically generated"
	^handle signedLongAt: 17! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
centerX: anObject
	"This method was automatically generated"
	handle signedLongAt: 17 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
centerY
	"This method was automatically generated"
	^handle signedLongAt: 21! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
centerY: anObject
	"This method was automatically generated"
	handle signedLongAt: 21 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
left
	"This method was automatically generated"
	^handle signedLongAt: 1! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
left: anObject
	"This method was automatically generated"
	handle signedLongAt: 1 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
right
	"This method was automatically generated"
	^handle signedLongAt: 9! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
right: anObject
	"This method was automatically generated"
	handle signedLongAt: 9 put: anObject! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
top
	"This method was automatically generated"
	^handle signedLongAt: 5! !

!ImageRectangle methodsFor: 'accessing' stamp: 'Richo 9/12/2012 16:16'!
top: anObject
	"This method was automatically generated"
	handle signedLongAt: 5 put: anObject! !
